
/*****************************************************************************/
/*                                                                           */
/*  Practica de Arquitectures Paral.leles                                    */
/*                                                                           */
/*  Execucio paral.lela del codi basada en els estandards de OpenMP          */
/*  Versio optimitzada per a 2 threads                                       */
/*                                                                           */
/*  Realitzada per: Francisco Jose Aguilar Celdran i Sergio Blanco Cuaresma  */
/*                                                                           */
/*****************************************************************************/ 


#include <stdio.h>
#include <assert.h>
#include <omp.h>

#define N 70000

int valors[N];

main()
{
   int i,j,k,min_index,minim;
   int num_iteracions;
   int thread_actual;
   int rang_menor,rang_major;
   double sum=0;
   FILE *ent, *sal;
   int taula_minim[2];
   int taula_min_index[2];
  
   for(i=0;i<N;i++) {
      valors[i] = rand(); 
   }

   omp_set_num_threads(2);
  
/*
   ent=fopen("sort.ent","w");
   assert(ent!=NULL);

   for(i=0;i<N;i++) fprintf(ent,"%d\n",valors[i]);
   close(ent);
*/

   for (i=0;i<N-1;i++)
   {
      taula_minim[0] = valors[i+1];
      taula_min_index[0] = i+1;
      taula_minim[1] = valors[i+1];
      taula_min_index[1] = i + 1;

      num_iteracions = N - (i + 2);
      #pragma omp parallel private(thread_actual,j,rang_menor,rang_major)
      {
         thread_actual = omp_get_thread_num();
         if (thread_actual == 0) {
            rang_menor = i + 2;
            rang_major = i + 2 + (num_iteracions / 2);
            for (j = rang_menor; j < rang_major; j++) {
               if (valors[j] < taula_minim[thread_actual])
               {
                  taula_minim[thread_actual] = valors[j];
                  taula_min_index[thread_actual] = j;
               }
            }
         }
         else {
            rang_menor = i + 2 + (num_iteracions / 2);
            rang_major = i + 2 + ((num_iteracions / 2) * 2);
            for (j = rang_menor; j < rang_major; j++) {
               if (valors[j] < taula_minim[thread_actual])
               {
                  taula_minim[thread_actual] = valors[j];
                  taula_min_index[thread_actual] = j;
               }
            }
         }
      }
      if ((taula_minim[1] <= taula_minim[0]) && (valors[i] > taula_minim[1])) {
         valors[taula_min_index[1]] = valors[i];
         valors[i] = taula_minim[1];
      } 
      else if (valors[i] > taula_minim[0]) {
         valors[taula_min_index[0]] = valors[i];
         valors[i] = taula_minim[0];
      }
   }

   // Amb la clausula reduction(+:sum) es crea una variable 'sum' per
   // a cada thread, i posteriorment es realitza la suma de totes elles
   #pragma omp parallel for reduction(+:sum)
   for (i=0;i<N;i++) {
      if (i%100) sum += valors[i];
   }

    
   sal=fopen("par2.sal","w");
   assert(sal!=NULL);

   fprintf(sal,"%f\n",sum);
   //for(i=0;i<N;i++) fprintf(sal,"%d\n",valors[i]);
   close(sal);
}


