
/*****************************************************************************/
/*                                                                           */
/*  Practica de Arquitectures Paral.leles                                    */
/*                                                                           */
/*  Execucio paral.lela del codi basada en els estandards de OpenMP          */
/*  Versio per a N threads                                                   */
/*                                                                           */
/*  Realitzada per: Francisco Jose Aguilar Celdran i Sergio Blanco Cuaresma  */
/*                                                                           */
/*****************************************************************************/ 


#include <stdio.h>
#include <assert.h>
#include <omp.h>

#define N 70000
#define MAX_THREADS 10

int valors[N];

main()
{
   int i,j,k,min_index,minim;
   int comptador,num_threads;
   int num_iteracions;
   int thread_actual;
   int rang_menor,rang_major;
   double sum=0;
   FILE *ent, *sal;
   int taula_minim[MAX_THREADS];
   int taula_min_index[MAX_THREADS];
  
   for(i=0;i<N;i++) {
      valors[i] = rand(); 
   }

   // Qualsevol numero de threads esta soportat.
   omp_set_num_threads(2);
   num_threads = 2;
  
/*
   ent=fopen("sort.ent","w");
   assert(ent!=NULL);

   for(i=0;i<N;i++) fprintf(ent,"%d\n",valors[i]);
   close(ent);
*/

   for (i=0;i<N-1;i++)
   {
      for(k = 0; k < num_threads; k++) {
         taula_minim[k] = valors[i+1];
         taula_min_index[k] = i+1;
      }
      num_iteracions = N - (i + 2);
      #pragma omp parallel private(thread_actual,j,comptador,rang_menor,rang_major)
      {
         thread_actual = omp_get_thread_num();
         for (comptador = 0; comptador < num_threads; comptador++) {
            if (thread_actual == comptador) {
               rang_menor = i + 2 + ((num_iteracions / num_threads) * (thread_actual));
               rang_major = i + 2 + ((num_iteracions / num_threads) * (thread_actual + 1));
               for (j = rang_menor; j < rang_major; j++) {
                  if (valors[j] < taula_minim[thread_actual])
                  {
                     taula_minim[thread_actual] = valors[j];
                     taula_min_index[thread_actual] = j;
                  }
               }
            }
         }
      }
      minim = taula_minim[0];
      min_index = taula_min_index[0];
      for (k = 1; k < num_threads; k++) {
         if (taula_minim[k] < minim) {
            minim = taula_minim[k];
            min_index = taula_min_index[k];
         } 
      }
      if (valors[i] > minim) {
         valors[min_index] = valors[i];
         valors[i] = minim;
      }
   }

   // Amb la clausula reduction(+:sum) es crea una variable 'sum' per
   // a cada thread, i posteriorment es realitza la suma de totes elles
   #pragma omp parallel for reduction(+:sum)
   for (i=0;i<N;i++) {
      if (i%100) sum += valors[i];
   }
    
   sal=fopen("par.sal","w");
   assert(sal!=NULL);

   fprintf(sal,"%f\n",sum);
   //for(i=0;i<N;i++) fprintf(sal,"%d\n",valors[i]);
   close(sal);
}


